import java.awt.*;

//Die Klasse DREIECK
public class DREIECK{
    
    //Attribute
    int hoehe;
    int laenge;
    int xPosition;
    int yPosition;
    String fuellfarbe;
    boolean istSichtbar;

    //Konstruktor
    DREIECK(){
        hoehe = 40;
        laenge = 70;
        xPosition = 50;
        yPosition = 15;
        fuellfarbe = "green";
        istSichtbar = false;
    }
    
    //Weitere Methoden
    public void sichtbarMachen(){
        istSichtbar = true;
        zeichnen();
    }
    
 
    void unsichtbarMachen(){
        loeschen();
        istSichtbar = false;
    }
    
    
    void nachRechts(){
        bewegeHorizontal(20);
    }

    void nachLinks(){
        bewegeHorizontal(-20);
    }

    void nachOben(){
        bewegeVertikal(-20);
    }

    void nachUnten(){
        bewegeVertikal(20);
    }

    void bewegeHorizontal(int strecke){
        loeschen();
        xPosition = xPosition + strecke;
        zeichnen();
    }

    void bewegeVertikal(int strecke){
        loeschen();
        yPosition = yPosition + strecke;
        zeichnen();
    }

    
    void bewegeLangsamHorizontal(int strecke){
        int delta;

        if(strecke < 0){
            delta = -1;
            strecke = -strecke;
        }
        else{
            delta = 1;
        }

        for(int i = 0; i < strecke; i++){
            xPosition = xPosition+delta;
            zeichnen();
        }
    }


    void bewegeLangsamVertikal(int strecke){
        int delta;

        if(strecke < 0){
            delta = -1;
            strecke = -strecke;
        }
        else{
            delta = 1;
        }

        for(int i = 0; i < strecke; i++){
            yPosition = yPosition+delta;
            zeichnen();
        }
    }

    void groesseSetzen(int neueHoehe, int neueLaenge){
        loeschen();
        hoehe = neueHoehe;
        laenge = neueLaenge;
        zeichnen();
    }
    
    //ndert die Farbe. Erlaubt sind "red", "yellow", "blue", "green", "magenta" und "black".
    void fuellfarbeSetzen(String neueFarbe){
        fuellfarbe = neueFarbe;
        zeichnen();
    }


    //Zeichnet das Dreieck auf die Leinwand (Canvas)
    private void zeichnen(){
        if(istSichtbar) {
            Canvas canvas = Canvas.getCanvas();
            int[] xpoints = { xPosition, xPosition + (laenge/2), xPosition - (laenge/2) };
            int[] ypoints = { yPosition, yPosition + hoehe, yPosition + hoehe };
            canvas.draw(this, fuellfarbe, new Polygon(xpoints, ypoints, 3));
            canvas.wait(10);
        }
    }

    //Entfernt das Dreieick von der Leinwand (Canvas)
    private void loeschen(){
        if(istSichtbar) {
            Canvas canvas = Canvas.getCanvas();
            canvas.erase(this);
        }
    }
} //Ende der Klasse DREIECK
