import java.awt.*;
import java.awt.geom.*;

//Die Klasse KREIS
public class KREIS{

    //Attribute
    int radius;
    int xPosition;
    int yPosition;
    String fuellfarbe;
    boolean istSichtbar;
    
    //Konstruktor
    public KREIS(){
        radius = 30;
        xPosition = 40;
        yPosition = 60;
        fuellfarbe = "red";
        istSichtbar = false;
    }

    //Weitere Methoden
    public void sichtbarMachen(){
        istSichtbar = true;
        zeichnen();
    }
    
 
    public void Verschieben(int xRichtung, int yRichtung) {
        xPosition = xPosition + xRichtung;
        yPosition = yPosition + yRichtung;
        zeichnen();
    }

    
    public void unsichtbarMachen(){
        loeschen();
        istSichtbar = false;
    }
    
    
    public void nachRechts(){
        bewegeHorizontal(20);
    }

    public void nachLinks(){
        bewegeHorizontal(-20);
    }

    public void nachOben(){
        bewegeVertikal(-20);
    }

    public void nachUnten(){
        bewegeVertikal(20);
    }


   public void bewegeHorizontal(int strecke){
        loeschen();
        xPosition = xPosition + strecke;
        zeichnen();
    }

    public void bewegeVertikal(int strecke){
        loeschen();
        yPosition = yPosition + strecke;
        zeichnen();
    }

    
    public void bewegeLangsamHorizontal(int strecke){
        int delta;

        if(strecke < 0){
            delta = -1;
            strecke = -strecke;
        }
        else{
            delta = 1;
        }

        for(int i = 0; i < strecke; i++){
            xPosition = xPosition+delta;
            zeichnen();
        }
    }


    public void bewegeLangsamVertikal(int strecke){
        int delta;

        if(strecke < 0){
            delta = -1;
            strecke = -strecke;
        }
        else{
            delta = 1;
        }

        for(int i = 0; i < strecke; i++){
            yPosition = yPosition+delta;
            zeichnen();
        }
    }


    public void groesseSetzen(int neuerRadius){
        loeschen();
        radius = neuerRadius;
        zeichnen();
    }

    //ndert die Farbe. Erlaubt sind "red", "yellow", "blue", "green", "magenta" und "black".
    public void fuellfarbeSetzen(String neueFarbe){
        fuellfarbe = neueFarbe;
        zeichnen();
    }

    //Zeichnet den Kreis auf die Leinwand (Canvas)
    private void zeichnen(){
        if(istSichtbar) {
            Canvas canvas = Canvas.getCanvas();
            canvas.draw(this, fuellfarbe, new Ellipse2D.Double(xPosition, yPosition, 
                                                          radius*2, radius*2));
            canvas.wait(10);
        }
    }

    //Entfernt den Kreis von der Leinwand (Canvas)
    private void loeschen(){
        if(istSichtbar) {
            Canvas canvas = Canvas.getCanvas();
            canvas.erase(this);
        }
    }
} //Ende der Klasse KREIS
